<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{{ title }}</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.3/css/bulma.min.css">
</head>
<body>
<section class="section">
    <div class="container">
        <div class="notification">
            <p class="title is-1 is-spaced">{{ report_title }}</p>
            <p class="subtitle is-3">{{ now() }}</p>
        </div>
    </div>
</section>
<section class="section">
    <div class="container">
        <div class="columns is-multiline is-mobile">
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Observed sequence
                    </div>
                    <div class="message-body">
                        <p>{{ observed_chain | wordwrap(15) }}</p>
                    </div>
                </article>
            </div>
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Alphabet
                    </div>
                    <div class="message-body">
                        <ul>
                            <li>{{ alphabet }}</li>
                        </ul>
                    </div>
                </article>
            </div>
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Hidden States
                    </div>
                    <div class="message-body">
                        <ul>
                            {% for state in hidden_states %}
                            <li>{{ state }}</li>
                            {% endfor %}
                        </ul>
                    </div>
                </article>
            </div>
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Selected algorithms
                    </div>
                    <div class="message-body">
                        <ol>
                            {% for alg in algorithms %}
                            {% if 'fo' in alg %}
                            <li>Forward</li>
                            {% endif %}
                            {% if 'ba' in alg %}
                            <li>Backward</li>
                            {% endif %}
                            {% if 'vi' in alg %}
                            <li>Viterbi</li>
                            {% endif %}
                            {% endfor %}
                        </ol>
                    </div>
                </article>
            </div>
        </div>
    </div>
</section>
<section>
    <div class="container">
        <div class="columns is-multiline is-mobile">
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Transition matrix
                    </div>
                    <div class="message-body">
                        {{ transition_data }}
                    </div>
                </article>
            </div>
            <!--WeasyPrint Page Break-->
            <p style="page-break-before: always"></p>
            <!---->
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Emission matrix
                    </div>
                    <div class="message-body">
                        {{ emission_data }}
                    </div>
                </article>
            </div>
        </div>
        <div class="columns is-multiline is-mobile">
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Prior Probabilities
                    </div>
                    <div class="message-body">
                        <ul>
                            {% for key, value in prior_values_data.items() %}
                            <li><b>{{ key }}</b> : {{ value }}</li>
                            {% endfor %}
                        </ul>
                    </div>
                </article>
            </div>
            {% if not backward_options %}
            <div class="column">
                <article class="message">
                    <div class="message-header">
                        Backward Options
                    </div>
                    <div class="message-body">
                        <ul>
                            {% for opt in backward_options %}
                            <li>{{opt}}</li>
                            {% endfor %}
                        </ul>
                    </div>
                </article>
            </div>
            {% endif %}
        </div>
    </div>
</section>

<!--WeasyPrint Page Break-->
<p style="page-break-before: always"></p>
<!---->
<section>
    <div class="container">
        {% for alg in algorithms %}
        {% if 'fo' in alg %}
        <article class="message">
            <div class="message-header">
                <b>Forward</b>
            </div>
            <div class="message-body">
                <b class="title">Initialization</b><br>
                <img src="{{ 'hmm/report/template/images/formulas/forward_init.png' }}">
                <br><b>T: 1</b><br>
                {{ forward_init_text }}
                <br><b class="title">Recursion</b><br>
                {{ forward_rec_text }}
                <br><b class="title">Termination</b><br><br>
                {{ forward_term_text }}
                <!--WeasyPrint Page Break-->
                <!--<p style="page-break-before: always"></p>-->
                <!---->
                <!--<br><br><b class="title">Matrix of &alpha; values</b><br><br>-->
                <!--<div class="table-container">-->
                <!--{{ forward_matrix }}-->
                <!--</div>-->
            </div>
        </article>
        {% endif %}
        {% if 'vi' in alg %}
        <!--WeasyPrint Page Break-->
        <p style="page-break-before: always"></p>
        <!---->
        <article class="message">
            <div class="message-header">
                <b>Viterbi</b>
            </div>
            <div class="message-body">
                <b class="title">Initialization</b><br><br>
                Where:
                <ul>
                    {% for state in hidden_states %}
                    <li>S<sub>{{ loop.index }}</sub> = {{ state }}</li>
                    {% endfor %}
                </ul>
                <br>
                &delta;<sub>0</sub> (S<sub>0</sub>) = 1 <br>
                {% for state in hidden_states %}
                &delta;<sub>0</sub> (S<sub>{{ loop.index }}</sub>) = 0 <br>
                {% endfor %}
                {{ viterbi_init_text }}
                <br><br><b class="title">Recursion</b>
                {{ viterbi_rec_text }}
                <!--WeasyPrint Page Break-->
                <p style="page-break-before: always"></p>
                <!---->
                <br><br><b class="title">Backtracking</b><br><br>
                <div class="content">
                    <ol>
                        <li>Each cell shows the delta corresponding to the particular hidden state at a particular
                            position of the observed sequence.
                        </li>
                        <li>In green is shown the calculated backtracking.</li>
                        <li>The backtracking starts on letter ({{ observed_chain[-1] }}) at the last position, going
                            back to the first letter ({{ observed_chain[0] }}) at the first position.
                        </li>
                    </ol>
                </div>
                <!--<div class="table-container">-->
                <!--{{ viterbi_matrix }}-->
                <!--</div>-->
                <br><b class="title">Termination</b><br>
                {{ viterbi_term_text }}
            </div>
        </article>
        {% endif %}
        {% if 'ba' in alg %}
        <!--WeasyPrint Page Break-->
        <p style="page-break-before: always"></p>
        <!---->
        <article class="message">
            <div class="message-header">
                <b>Backward</b>
            </div>
            <div class="message-body">
                {{ backward_intro_text }}
                <br><br><b class="title">Initialization</b><br><br>
                <div class="content">
                    <ol>
                        <li>The length of observed sequence is: {{ observed_chain|length }}.</li>
                        <li>The probability of being in the last observed states will be 1.</li>
                        <li>There are {{ hidden_states|length }} hidden states.</li>
                    </ol>
                </div>
                {% for state in hidden_states %}
                &beta;({{ observed_chain|length }},{{ loop.index }}) = 1 <br>
                {% endfor %}
                {{ backward_rec_text }}
                <br><br><b class="title">Termination</b><br><br>
                {{ backward_ter_text }}
                <!--WeasyPrint Page Break-->
                <!--<p style="page-break-before: always"></p>-->
                <!---->
                <!--<br><b class="title">Matrix of &beta; values</b><br><br>-->
                <!--<div class="table-container">-->
                <!--{{ forward_backward_matrix }}-->
                <!--</div>-->
            </div>
        </article>
        {% endif %}
        {% endfor %}
    </div>
</section>
<footer class="footer">
    <div class="content has-text-centered">
        <p>
            <strong>HMMTeacher</strong> was developed by Camilo Fuentes Beals at the Biological Sequence Analysis group,
            in the Center for Bioinformatics, Simulation and Modeling, CBSM, at the University of Talca, Chile. - {{
            year }}.
        </p>
    </div>
</footer>
</body>
</html>
